#!/bin/bash

set -e  # Exit immediately if a command exits with a non-zero status

CURRENT_DATE=$(date +%Y-%m-%d)
AI_LOG_FILE="AI_LOG.md"
AI_LOGS_DIR="ai-logs"

# Check if AI_LOG.md exists
if [ ! -f "$AI_LOG_FILE" ]; then
  echo "Error: '$AI_LOG_FILE' not found."
  exit 1
fi

# Check if ai-logs directory exists
if [ ! -d "$AI_LOGS_DIR" ]; then
  echo "Error: '$AI_LOGS_DIR' directory not found."
  exit 1
fi

echo "Adding protection to AI-generated files..."

# Add warning header to AI_LOG.md
TMP_FILE=$(mktemp)
cat << EOF > "$TMP_FILE"
# IMPORTANT: THIS FILE IS AUTO-GENERATED BY AI
# DO NOT MODIFY DIRECTLY - Changes will be overwritten
# To make changes, create or update individual log files in ai-logs/ 
# and then run update_ai_log.sh to regenerate this file
# Last updated: $CURRENT_DATE

EOF

# Append existing content, skipping any existing warning headers
grep -v "^# IMPORTANT:" "$AI_LOG_FILE" | grep -v "^# DO NOT MODIFY" | grep -v "^# To make" | grep -v "^# Last updated" | grep -v "^# and then run" >> "$TMP_FILE"

# Replace the original file with the temporary file
mv "$TMP_FILE" "$AI_LOG_FILE"

# Make AI_LOG.md read-only
chmod 444 "$AI_LOG_FILE"
echo "Added protection to $AI_LOG_FILE"

# Process all markdown files in ai-logs directory
for LOG_FILE in "$AI_LOGS_DIR"/*.md; do
  if [ -f "$LOG_FILE" ]; then
    
    # Extract AI info if possible
    AI_TOOL=$(grep "Tool name:" "$LOG_FILE" | sed 's/- Tool name: //' | head -n 1)
    AI_MODEL=$(grep "Model identifier:" "$LOG_FILE" | sed 's/- Model identifier: //' | head -n 1)
    
    # Default values if not found
    if [ -z "$AI_TOOL" ]; then
      AI_TOOL="Claude Code"
    fi
    
    if [ -z "$AI_MODEL" ]; then
      AI_MODEL="claude-3-7-sonnet-20250219"
    fi
    
    # Add warning header if not already present
    if ! grep -q "IMPORTANT: THIS FILE IS AUTO-GENERATED" "$LOG_FILE"; then
      TMP_LOG=$(mktemp)
      cat << EOF > "$TMP_LOG"
<!-- 
IMPORTANT: THIS FILE IS AUTO-GENERATED BY AI
DO NOT MODIFY DIRECTLY - Changes may be overwritten
Generated by: $AI_TOOL ($AI_MODEL)
Date: $CURRENT_DATE
-->

EOF
      cat "$LOG_FILE" >> "$TMP_LOG"
      mv "$TMP_LOG" "$LOG_FILE"
      echo "Added warning header to $LOG_FILE"
    else
      echo "Warning header already exists in $LOG_FILE"
    fi
    
    # Make the log file read-only
    chmod 444 "$LOG_FILE"
    echo "Set $LOG_FILE to read-only"
  fi
done

echo "All AI-generated files have been protected."
echo "To modify these files:"
echo "1. Use chmod 644 <filename> to make a file writable"
echo "2. After editing, run protect_ai_files.sh again to reapply protection"
echo "3. For AI_LOG.md, use update_ai_log.sh instead of direct editing"